## Xalan-C++ API Documentation

### The Xalan C++ XSLT Processor Version 1.9

Main Page | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | File Members | Related Pages

# XalanList< Type > Class Template Reference

Xalan implementation of a doubly linked list. More...

Collaboration diagram for XalanList< Type >:

[legend]
List of all members.

## Public Types

- typedef Type value_type
- typedef value_type * pointer
- typedef const value_type * const_pointer
- typedef value_type & reference
- typedef const value_type & const_reference
- typedef size_t size_type
- typedef XalanList< value_type > ThisType
- typedef XalanListIteratorBase<
  XalanListIteratorTraits<
  value_type >, Node > iterator
- typedef XalanListIteratorBase<
  XalanListConstIteratorTraits<
  value_type >, Node > const_iterator
- typedef XALAN_STD_QUALIFIER
  reverse_iterator< iterator,
  value_type > reverse_iterator_
- typedef XALAN_STD_QUALIFIER
  reverse_iterator< const_iterator,
  value_type, const_reference > const_reverse_iterator_
- typedef reverse_iterator_ reverse_iterator
- typedef const_reverse_iterator_ const_reverse_iterator
- typedef MemoryManagedConstructionTraits<
  value_type >::Constructor Constructor

## Public Member Functions

- XalanList (MemoryManagerType &theManager)
- ~XalanList ()
- MemoryManagerType & getMemoryManager ()
- const MemoryManagerType & getMemoryManager () const
- iterator begin ()
- const_iterator begin () const
- iterator end ()
- const_iterator end () const
- reverse_iterator rbegin ()
- const_reverse_iterator rbegin () const
- reverse_iterator rend ()
- const_reverse_iterator rend () const
- reference front ()
- reference back ()
- size_type size () const
- bool empty () const
- void push_back (const value_type &data)
- void push_front (const value_type &data)
- void pop_front ()
- void pop_back ()
- iterator insert (const iterator &pos, const value_type &value)
- void erase (iterator pos)
- void splice (iterator pos, ThisType &list, iterator toInsert)
- void splice (iterator pos, ThisType &list, iterator toInsertFirst, iterator toInsertLast)
- void clear ()
- void swap (ThisType &theRHS)

## Protected Member Functions

- Node & constructNode (const value_type &data, iterator pos)
- void freeNode (Node &node)
- void destroyNode (Node &node)
- Node & getListHead ()
- Node & getListHead () const
- Node * allocate (size_type size)
- void deallocate (Node *pointer)

## Protected Attributes

- MemoryManagerType * m_memoryManager
- Node * m_listHead
- Node * m_freeListHeadPtr

## Detailed Description

### template<class Type>
class XalanList< Type >

Xalan implementation of a doubly linked list.

## Member Typedef Documentation

template<class Type>
typedef XalanListIteratorBase<XalanListConstIteratorTraits<value_type>, Node> XalanList< Type >::const_iterator

template<class Type>
typedef const value_type* XalanList< Type >::const_pointer

template<class Type>
typedef const value_type& XalanList< Type >::const_reference

template<class Type>
typedef const_reverse_iterator_ XalanList< Type >::const_reverse_iterator

template<class Type>
typedef XALAN_STD_QUALIFIER reverse_iterator<const_iterator, value_type, const_reference> XalanList< Type >::const_reverse_iterator_

template<class Type>
typedef MemoryManagedConstructionTraits<value_type>::Constructor XalanList< Type >::Constructor

template<class Type>
typedef XalanListIteratorBase<XalanListIteratorTraits<value_type>, Node> XalanList< Type >::iterator

template<class Type>
typedef value_type* XalanList< Type >::pointer

template<class Type>
typedef value_type& XalanList< Type >::reference

template<class Type>
typedef reverse_iterator_ XalanList< Type >::reverse_iterator

template<class Type>
typedef XALAN_STD_QUALIFIER reverse_iterator<iterator, value_type> XalanList< Type >::reverse_iterator_

template<class Type>
typedef size_t XalanList< Type >::size_type

template<class Type>
typedef XalanList<value_type> XalanList< Type >::ThisType

template<class Type>
typedef Type XalanList< Type >::value_type

## Constructor & Destructor Documentation

template<class Type>
XalanList< Type >::XalanList | ( | MemoryManagerType & | theManager | ) |

template<class Type>
XalanList< Type >::~XalanList | ( |  | ) |

## Member Function Documentation

template<class Type>
Node* XalanList< Type >::allocate | ( | size_type | size | ) | `[protected]`

template<class Type>
reference XalanList< Type >::back | ( |  | ) |

template<class Type>
const_iterator XalanList< Type >::begin | ( |  | ) | const

template<class Type>
iterator XalanList< Type >::begin | ( |  | ) |

template<class Type>
void XalanList< Type >::clear | ( |  | ) |

template<class Type>
Node& XalanList< Type >::constructNode | ( | const value_type & | data,
|  | iterator | pos
| ) | `[protected]`

template<class Type>
void XalanList< Type >::deallocate | ( | Node * | pointer | ) | `[protected]`

template<class Type>
void XalanList< Type >::destroyNode | ( | Node & | node | ) | `[protected]`

template<class Type>
bool XalanList< Type >::empty | ( |  | ) | const

template<class Type>
const_iterator XalanList< Type >::end | ( |  | ) | const

template<class Type>
iterator XalanList< Type >::end | ( |  | ) |

template<class Type>
void XalanList< Type >::erase | ( | iterator | pos | ) |

template<class Type>
void XalanList< Type >::freeNode | ( | Node & | node | ) | `[protected]`

template<class Type>
reference XalanList< Type >::front | ( |  | ) |

template<class Type>
Node& XalanList< Type >::getListHead | ( |  | ) | const`[protected]`

template<class Type>
Node& XalanList< Type >::getListHead | ( |  | ) | `[protected]`

template<class Type>
const MemoryManagerType& XalanList< Type >::getMemoryManager | ( |  | ) | const

template<class Type>
MemoryManagerType& XalanList< Type >::getMemoryManager | ( |  | ) |

template<class Type>
iterator XalanList< Type >::insert | ( | const iterator & | pos,
|  | const value_type & | value
| ) |

template<class Type>
void XalanList< Type >::pop_back | ( |  | ) |

template<class Type>
void XalanList< Type >::pop_front | ( |  | ) |

template<class Type>
void XalanList< Type >::push_back | ( | const value_type & | data | ) |

template<class Type>
void XalanList< Type >::push_front | ( | const value_type & | data | ) |

template<class Type>
const_reverse_iterator XalanList< Type >::rbegin | ( |  | ) | const

template<class Type>
reverse_iterator XalanList< Type >::rbegin | ( |  | ) |

template<class Type>
const_reverse_iterator XalanList< Type >::rend | ( |  | ) | const

template<class Type>
reverse_iterator XalanList< Type >::rend | ( |  | ) |

template<class Type>
size_type XalanList< Type >::size | ( |  | ) | const

template<class Type>
void XalanList< Type >::splice | ( | iterator | pos,
|  | ThisType & | list,
|  | iterator | toInsertFirst,
|  | iterator | toInsertLast
| ) |

template<class Type>
void XalanList< Type >::splice | ( | iterator | pos,
|  | ThisType & | list,
|  | iterator | toInsert
| ) |

template<class Type>
void XalanList< Type >::swap | ( | ThisType & | theRHS | ) |

## Member Data Documentation

template<class Type>
Node* XalanList< Type >::m_freeListHeadPtr`[protected]`

template<class Type>
Node* XalanList< Type >::m_listHead`[protected]`

template<class Type>
MemoryManagerType* XalanList< Type >::m_memoryManager`[protected]`

The documentation for this class was generated from the following file:

- XalanList.hpp

Interpreting class diagrams

Doxygen and GraphViz are used to generate this API documentation from the Xalan-C header files.

Xalan-C++ XSLT Processor Version 1.9 Copyright © 1999-2004 The Apache Software Foundation. All Rights Reserved.